<!-- Harness2.cfm  -->
<!--- -->
<fusedoc fuse="Harness2.cfm" language="ColdFusion" specification="2.0">
  <responsibilities>
    I read the fusedoc from a fuse and generate a suitable unit test harness.
  </responsibilities>
  <properties>
    <author name="Jeff Peters" email="jeff@grokfusebox.com">
    <history date="10/23/01" author="jsp" type="create" />
    <history date="08/20/02" author="jsp" type="update" />
    <history date="01/01/03" author="jsp" type="update">Version 1.02</history>
    <history date="01/17/03" author="jsp" type="update">Version 1.03</history>
    <history date="19/Jan/03" author="kevin@objectiveinternet.com" type="update">Merge with Steves FBtest</history>
    <history date="23/Jan/03" author="kevin@objectiveinternet.com" type="update">Fix bugs with arrays and structures</history>
    <history date="31/Jan/03" author="jsp" type="update">Version 1.04</history>
  </properties>
  <io>
    <in>
      <string name="thisDir" scope="attributes" optional="Yes" comments="directory from which to start process" />
      <boolean name="verbose" scope="attributes" optional="Yes" default="FALSE" />
      <list name="prefixes" scope="attributes" comments="file prefixes to process" />
      <string name="ini" scope="attributes" optional="Yes" comments="file that contains settings" default="harness.ini" />
      <string name="h2act" scope="attributes" optional="Yes" default="main" />
      <string name="fuseFile" scope="attributes" optional="Yes" default="" oncondition="h2act EQ 'parseFusedoc'" />
      <string name="testFile" scope="attributes" optional="Yes" default="" oncondition="h2act NEQ 'main' or empty" />
      <boolean name="setfusebeingtested" scope="attributes" optional="Yes" default="No" comments="Adds a line which set a variable contaning the name of the fuse."/> 
      <boolean name="onlyexecutefuseonce" scope="attributes" optional="Yes" default="No" comments="Adds lines that check if this is first or subsequent execution of the harness."/>
      <boolean name="addfusedocdata" scope="attributes" optional="Yes" default="No" comments="Adds lines to create a wddx copy of the fusedoc in the harness for use in validating output variables."/>
      <boolean name="includesubdirs" scope="attributes" optional="Yes" default="Yes" comments="Creates test harnesses for fuses in the subdirectories as well."/>
      <boolean name="StopOnXMLError" scope="attributes" optional="Yes" default="Yes" comments="Aborts the process if an XML error is found in any of the fusedocs."/>
    </in>
  </io>
</fusedoc>
--->
<cfif thisTag.ExecutionMode EQ "start">
<cfparam name="attributes.thisDir" default="#GetDirectoryFromPath(GetCurrentTemplatePath())#">
<cfparam name="attributes.prefixes" default = "dsp,act">
<cfparam name="attributes.verbose" default = "TRUE">
<cfparam name="attributes.ini" default="#GetDirectoryFromPath(GetCurrentTemplatePath())#harness2.ini">
<cfparam name="attributes.h2act" default="main">
<cfparam name="attributes.lineStyle" default="cfset">
<cfparam name="attributes.namePrefix" default="">
<cfparam name="prefixLen" default = "#Len(ListFirst(attributes.prefixes))#">
<cfparam name="fuseFile" default="">
<cfparam name="attributes.setfusebeingtested" default="No">
<cfparam name="attributes.onlyexecutefuseonce" default="No">
<cfparam name="attributes.addfusedocdata" default="No">
<cfparam name="attributes.includesubdirs" default="Yes">
<cfparam name="attributes.StopOnXMLError" default="Yes">

<cfif not isDefined("request.stylesLoaded")>
  <cfoutput><style type="text/css">
  <!--
  .titleLine {
    font-family : Verdana, Geneva, Arial, Helvetica, sans-serif;
    font-size : 10pt;
    font-variant : small-caps;
    font-weight : bold;
  }
  .dataLine{
    font-family : Verdana, Geneva, Arial, Helvetica, sans-serif;
    font-size : 9pt;
  }
  .errorLine{
    font-family : Verdana, Geneva, Arial, Helvetica, sans-serif;
    font-size : 9pt;
    color : red;
  }
  -->
  </style></cfoutput>
  <cfset request.stylesLoaded = True>
</cfif>

<cfif attributes.verbose EQ "Yes" and attributes.h2act EQ "main">
  <cfoutput><hr><span class="titleLine">
  Harness2 v 1.04 - rundate: #Dateformat(Now())#, #TimeFormat(Now())#
  <hr></span></cfoutput>
</cfif>

<cfset Crlf = Chr(10)>
<cfset lstScopes = "Server,Application,Session,Client,Cookie,Request,Attributes,Caller,CGI">
<cfset lstSimpleDataTypes = "STRING,NUMBER,DATETIME,BOOLEAN,LIST,COOKIE,FILE">
<cfset lstComplexDataTypes = "ARRAY,STRUCTURE,RECORDSET">
<cfset lstIgnoreTypes = "ATTRIBUTES,VALUE">
<cfset fdBegin = "<fusedoc">
<cfset fdEnd = "</fusedoc>">
<cfset inFusedoc = "False">

<cfoutput>
<cfswitch expression="#attributes.h2act#">
  <cfcase value="main">
    <!--- Set variable for ini file, including default directory if necessary. --->
    <cfparam name="attributes.ini" default = "#attributes.thisDir#\harness2.ini">
    <cfif Find("\",attributes.ini) EQ 0>
      <cfset attributes.ini = "#attributes.thisDir#\#attributes.ini#">
    </cfif>
    
    <!--- Read test harness initialization lines from ini file. --->
    <cfset initLines = "">
    <cfset initLines = initLines & "<!--- ********************************************************* --->#crlf#">
    <cfset initLines = initLines & "<!--- The following lines are copied from the .ini file         --->#crlf#">
    <cfset initLines = initLines & "<!---   [Settings] in #attributes.ini#  --->#crlf#">
    <cfset initLines = initLines & "<!--- ********************************************************* --->#crlf#">
    <cfset iniLineCount = GetProfileString(attributes.ini,"Settings","LineCount")>
    <cfif iniLineCount GT 0>
      <cfloop from="1" to="#iniLineCount#" index="iniLineNum">
        <cfset initLines = initLines & crlf & GetProfileString(attributes.ini,"Settings","Line#iniLineNum#")>
      </cfloop>
    </cfif>
  
  <!--- Read test harness closing lines from ini file. --->
    <cfset closeLines = "">
    <cfset closeLines = closeLines & "<!--- ********************************************************* --->#crlf#">
    <cfset closeLines = closeLines & "<!--- The following lines are copied from the .ini file         --->#crlf#">
    <cfset closeLines = closeLines & "<!---   [ShowResults] in #attributes.ini#  --->#crlf#">
    <cfset closeLines = closeLines & "<!--- ********************************************************* --->#crlf#">
    <cfset iniLineCount = GetProfileString(attributes.ini,"ShowResults","LineCount")>
    <cfif iniLineCount GT 0>
      <cfloop from="1" to="#iniLineCount#" index="iniLineNum">
        <cfset closeLines = closeLines & crlf & GetProfileString(attributes.ini,"ShowResults","Line#iniLineNum#")>
      </cfloop>
    </cfif>
  
    <!--- Read the author name and email --->
    <cfset authorName = GetProfileString(attributes.ini,"UserData","authorName")>
    <cfset authorEMail = GetProfileString(attributes.ini,"UserData","authorEMail")>
    
    <!--- Trim trailing slash from directory. --->
    <cfif Right(attributes.thisDir,1) EQ "\">
      <cfset attributes.thisDir = Left(attributes.thisDir,Len(attributes.thisDir)-1)>
    </cfif>
    
    <!--- Read directory entries into array --->
    <cfif attributes.verbose EQ "Yes">
      <span class="dataLine">
      Reading directory #attributes.thisDir#.<br>
      </span>
    </cfif>
    <cfdirectory name="qryThisDir"
               action="LIST"
            directory="#attributes.thisDir#">
    
    <!--- For each entry in files array: --->
    <cfloop query="qryThisDir">
      <!--- Select based on entry type: --->
      <cfswitch expression="#Trim(qryThisDir.type)#">
        <cfcase value="File">
          <!--- If prefix is in prefixes list, or prefix list is "*": --->
          <cfset validPrefix = FindNoCase(Left(#qryThisDir.Name#,prefixLen),attributes.prefixes)>
          <cfif  (validPrefix GT 0) OR ("#attributes.prefixes#" EQ "*")>
            <cfset request.fuseFileName = qryThisDir.Name>
            <cfif attributes.verbose EQ "Yes">
              <span class="dataLine">
              Writing harness for #request.fuseFileName#.<br>
              </span>
            </cfif>
            <!--- Write harness file header and fusedoc --->
            <cfset request.testHarness="">
            <cfset request.testHarness="#attributes.thisDir#\tst_#request.fuseFileName#">
            <cfset fileLines = "">
            <cfset fileLines = fileLines & "<!-- tst_#qryThisDir.Name# -->#crlf#">
            <cfset fileLines = fileLines & "<!--- -->#crlf#">
            <cfset fileLines = fileLines & "<fusedoc fuse=""tst_#qryThisDir.Name#"" language=""ColdFusion"" specification=""2.0"">#crlf#">
            <cfset fileLines = fileLines & "<responsibilities>#crlf#">
            <cfset fileLines = fileLines & "  I am a unit test harness for the #qryThisDir.Name# fuse.#crlf#">
            <cfset fileLines = fileLines & "</responsibilities>#crlf#">
            <cfset fileLines = fileLines & "<properties>#crlf#">
            <cfset fileLines = fileLines & "  <history date=""#DateFormat(Now(),'dd/mmm/yyyy')#"" author=""#authorName#"" email=""#authorEmail#"" type=""create""/>#crlf#">
            <cfset fileLines = fileLines & "</properties>#crlf#">
            <cfset fileLines = fileLines & "</fusedoc>#crlf#">
            <cfset fileLines = fileLines & " --->#crlf#">
      
            <cffile action="WRITE" 
                      file="#request.testHarness#" 
                    output="#fileLines##crlf#"
                addnewline="No">
        
            <!--- Write global lines to file based on ini file. --->
            <cffile action="APPEND" 
                      file="#request.testHarness#" 
                    output="#initLines##crlf#"
                addnewline="No">
        
            <cfset fusedocLines = "">
            <cfset fusedocLines = fusedocLines & "<!--- ********************************************************* --->#crlf#">
            <cfset fusedocLines = fusedocLines & "<!--- The following lines are generated from the fusedoc.       --->#crlf#">
            <cfset fusedocLines = fusedocLines & "<!--- ********************************************************* --->#crlf#">
            <cffile action="APPEND" 
                          file="#request.testHarness#" 
                        output="#fusedocLines##crlf#"
                    addnewline="No">
          
            <cftry>
            <!--- Process the Fusedoc --->
                  <cf_harness2 thisDir="#attributes.thisDir#"
                               verbose="#attributes.verbose#"
                                 h2act="parseFusedoc"
                              fuseFile="#request.fuseFileName#"
                              testFile="#request.testHarness#"
                addfusedocdata="#attributes.addfusedocdata#">
            
            <cfset fuseLines = "">
            <cfset fuseLines = fuseLines & "<!--- ********************************************************* --->#crlf#">
            <cfset fuseLines = fuseLines & "<!--- Now include the fuse to be tested.                        --->#crlf#">
            <cfset fuseLines = fuseLines & "<!--- ********************************************************* --->#crlf#">
            <!--- Put in a line showiing the name of the fuse being tested --->
            <cfif attributes.setfusebeingtested>
              <cfset fuseLines = fuseLines & "<cfset fusebeingtested = ""#qryThisDir.Name#"">#crlf#">
            </cfif>
            
            <!--- Line to test if this is first execution, Line for the fuse bing tested and end of the cfif--->
            <cfif attributes.onlyexecutefuseonce>
              <cfset fuseLines = fuseLines & "<cfif tmpincludefilecount lt 2>#crlf#">
              <cfset fuseLines = fuseLines & "  <cfinclude template=""#qryThisDir.Name#"">#crlf#">
              <cfset fuseLines = fuseLines & "</cfif>#crlf#">
            <cfelse>
              <cfset fuseLines = fuseLines & "<cfinclude template=""#qryThisDir.Name#"">#crlf#">
            </cfif>
                  <!--- Write the lines for the fuse file and execution count test. --->
                  <cffile action="APPEND" 
                            file="#request.testHarness#" 
                          output="#fuseLines#">
            
            <!--- Add the ending file to display the results --->
            <!--- Write global lines to file based on ini file. --->
                  <cffile action="APPEND" 
                            file="#request.testHarness#" 
                          output="#closeLines##crlf#"
                      addnewline="No">
               
            <cfcatch type="XML">
            <cfif attributes.StopOnXMLError>
              <br>Test Harness Generation Halted.<br>
              <cffile action="DELETE" file="#request.testHarness#">
              <cfthrow type="XML" detail="#cfcatch.detail#" message="#cfcatch.message#">
            <cfelse>
              Skipping File<br>
              <cffile action="DELETE" file="#request.testHarness#">
            </cfif>
            </cfcatch>
            </cftry>
          </cfif>
        </cfcase>
        <cfcase value="Dir">
          <!--- Prevent recursion of the entire hard drive --->
          <cfif not ListFind(".,..",qryThisDir.Name) AND attributes.includesubdirs>
            <!--- If directory entry, recurse with main   --->
            <cf_harness2 thisDir="#attributes.thisDir#\#qryThisDir.Name#"
                         verbose="#attributes.verbose#"
                        prefixes="#attributes.prefixes#"
                             ini="#attributes.ini#">
          </cfif>
        </cfcase>
        <cfdefaultcase>
          No handler for #qryThisDir.type#.
        </cfdefaultcase>
      </cfswitch>
    </cfloop>
  <cfif attributes.verbose EQ "Yes">

  <hr><span class="titleLine">
  Directory #attributes.thisDir# completed.
  <hr></span>
  </cfif>
  </cfcase>

  <cfcase value="parseFusedoc">
    <cfset lstThisFusedoc = "">
    <!--- Read Fusedoc --->
    <cffile action="read" 
          variable="strRawInput" 
              file="#attributes.thisDir#\#request.fuseFileName#">
    <!--- For each line in file input: --->
    <cfloop list="#strRawInput#" delimiters="#crlf#" index="thisLine">
      <!--- Set inFusedoc flag --->
      <cfif FindNoCase(fdBegin,thisLine)>
        <cfset inFusedoc = True>
      </cfif>
      <cfif FindNoCase(fdEnd,thisLine)>
        <cfset inFusedoc = False>
        <cfset lstThisFusedoc = "#lstThisFusedoc##fdEnd#">
      </cfif>
      <!--- If the line is within the Fusedoc --->
      <cfif inFusedoc>
        <!--- Add line to thisFusedoc list --->
        <cfset lstThisFusedoc = "#lstThisFusedoc##thisLine#">
        <cfif lstThisFusedoc GT "">
          <cfset lstThisFusedoc = "#lstThisFusedoc##crlf#">
        </cfif>
      </cfif>
    </cfloop>
    <!--- Convert Fusedoc XML into CF complex data --->
    <cftry>
      <cf_SOXML action="XML2CF"
                 input="#lstThisFusedoc#"
                output="myFusedoc">
    <!--- <cfdump var="#myFusedoc#"><cfabort> --->
    
     <!--- Insert the fusedoc in WDDX format if requested --->
    <cfif attributes.addfusedocdata>
      <cfwddx action="CFML2WDDX" input="#myFusedoc#" output="outputLine">
      <cfset outputLine="<cfset TestHarnessFusedoc=""" & outputline & """>">
      <cffile action="APPEND" 
                  file="#request.testHarness#" 
                output="#outputLine#">
      <!--- Line to decode the wddx --->
      <cffile action="APPEND" 
                  file="#request.testHarness#" 
                output="<cfwddx action=""WDDX2CFML"" input=""##TestHarnessFusedoc##"" output=""myfusedoc"">#crlf#">
    </cfif>
    
      <cfcatch type="Any">
        <cfset errorMsg = "There is an XML syntax error in the Fusedoc for #request.fuseFileName#.<br>#cfcatch.Detail#">
        <cfif attributes.verbose>
        <span class="errorLine">
          #errorMsg#
        </span>
        </cfif>
        <cfthrow message="#errorMsg#" type="XML">
      </cfcatch>   
     </cftry>
    <!--- Loop over In section, if it exists --->
    <!--- NOTE: If datatype vars are single, they are structs.  If multiple, they are arrays of structs. --->
    <cfif IsDefined("myFusedoc.fusedoc.io.in")>
      <cf_harness2 thisDir="#attributes.thisDir#"
                   verbose="#attributes.verbose#"
                     h2act="procDocSection"
                 varStruct="#Duplicate(myFusedoc.fusedoc.io.in)#">
    </cfif>
                 
    <!--- Loop over Passthrough section, if it exists --->
    <cfif IsDefined("myFusedoc.fusedoc.io.passthrough")>
      <cf_harness2 thisDir="#attributes.thisDir#"
                   verbose="#attributes.verbose#"
                     h2act="procDocSection"
                 varStruct="#Duplicate(myFusedoc.fusedoc.io.passthrough)#">
    </cfif>
  </cfcase>
  
  <cfcase value="procDocSection">
    <cfloop collection="#attributes.varStruct#" item="inItem">
      <cfif isArray(attributes.varStruct[inItem])>
        <!--- Loop over array --->
        <cfloop from="1" to="#ArrayLen(attributes.varStruct[inItem])#" index="i">
          <cfset variables.thisDataType = inItem>
          <!--- If it's a simple data type, call writer; else call handler --->          
          <cfif ListFindNoCase(lstSimpleDataTypes,variables.thisDataType)>
            <cf_harness2 thisDir="#attributes.thisDir#"
                         verbose="#attributes.verbose#"
                           h2act="write#variables.thisDataType#Line"
                       varStruct="#Duplicate(attributes.varStruct[inItem][i])#"
                        testFile="#request.testHarness#">
          <cfelseif ListFindNoCase(lstComplexDataTypes,variables.thisDataType)>
            <cf_harness2 thisDir="#attributes.thisDir#"
                         verbose="#attributes.verbose#"
                           h2act="handle#variables.thisDataType#"
                       varStruct="#Duplicate(attributes.varStruct[inItem][i])#"
                        testFile="#request.testHarness#">
          <cfelse>
            <cfif not ListFindNoCase(lstIgnoreTypes,variables.thisDataType)>
              Invalid datatype: #variables.thisDataType#<br>
            </cfif>
          </cfif>
        </cfloop>
      <cfelse>
        <!--- If it's a simple data type, call writer; else call handler --->
          <cfset variables.thisDataType = inItem>
          <cfif ListFindNoCase(lstSimpleDataTypes,inItem)>
            <cf_harness2 thisDir="#attributes.thisDir#"
                         verbose="#attributes.verbose#"
                           h2act="write#variables.thisDataType#Line"
                       varStruct="#Duplicate(attributes.varStruct[inItem])#"
                        testFile="#request.testHarness#">
          <cfelseif ListFindNoCase(lstComplexDataTypes,inItem)>
            <cf_harness2 thisDir="#attributes.thisDir#"
                         verbose="#attributes.verbose#"
                           h2act="handle#variables.thisDataType#"
                       varStruct="#Duplicate(attributes.varStruct[inItem])#"
                        testFile="#request.testHarness#">
          </cfif>
      </cfif>
    </cfloop>
  </cfcase>
  
  <cfcase value="handleARRAY">
    <!--- If it's an array (more than one <array> tag), deal with each one individually --->
    <cfif IsArray(attributes.varStruct)>
      <cfloop from="1" to="#ArrayLen(attributes.varStruct)#" index="i">
        <cf_harness2 thisDir="#attributes.thisDir#"
                     verbose="#attributes.verbose#"
                       h2act="handleARRAY"
                   varStruct="#Duplicate(attributes.varStruct[i])#"
          namePrefix="#attributes.namePrefix#"
                    testFile="#request.testHarness#">
      </cfloop>
    <cfelse>
      <!--- Write arrayNew line --->
    <cfif attributes.namePrefix IS "">
      <cfif isdefined("attributes.varStruct.attributes.scope")>
      <cfset prefixToPass = attributes.varStruct.attributes.scope & ".">
    <cfelse>
      <cfset prefixToPass = "">
    </cfif>
    <cfelse>
      <cfset prefixToPass = "#attributes.namePrefix#">
    </cfif>
    
      <cfset outputLine = "<cfset #prefixToPass##attributes.varStruct.attributes.name# = ArrayNew()>">
      <cffile action="APPEND" 
                file="#request.testHarness#" 
              output="#outputLine#"
      addnewline="Yes">
      
    <cfset prefixToPass = "#prefixToPass##attributes.varStruct.attributes.name#[1]">
      <!--- Loop over structure --->
      <cfloop collection="#attributes.varStruct#" item="thisLine">
        <cfif ListFindNoCase(lstSimpleDataTypes,thisLine)>
        <!--- If simple, write line --->
          <cfif IsArray(attributes.varStruct[thisLine])>
            <cfloop from="1" to="#ArrayLen(attributes.varStruct[thisLine])#" index="i">
              <cf_harness2 thisDir="#attributes.thisDir#"
                           verbose="#attributes.verbose#"
                             h2act="write#thisLine#Line"
                         varStruct="#Duplicate(attributes.varStruct[thisLine])#"
            namePrefix="#prefixToPass#"
                          testFile="#request.testHarness#"
                         linestyle="array">
            </cfloop>
          <cfelse>
            <cf_harness2 thisDir="#attributes.thisDir#"
                         verbose="#attributes.verbose#"
                           h2act="write#thisLine#Line"
                       varStruct="#Duplicate(attributes.varStruct[thisLine])#"
            namePrefix="#prefixToPass#"
                        testFile="#request.testHarness#"
                       linestyle="array">
          </cfif>
        <cfelseif listFind(lstComplexDataTypes,thisLine)>
        <!--- If complex, recurse --->
          <cf_harness2 thisDir="#attributes.thisDir#"
                       verbose="#attributes.verbose#"
                         h2act="handle#thisLine#"
                     varStruct="#Duplicate(attributes.varStruct[thisLine])#"
          namePrefix="#prefixToPass#"
                      testFile="#request.testHarness#"
           linestyle="array">
        <cfelse>
          <cfif not ListFindNoCase(lstIgnoreTypes,thisLine)>
            Invalid data type in array: #thisLine#<br>
          </cfif>
        </cfif>
      </cfloop>
      <!--- If WDDX, write serialize line --->
      <cfif IsDefined("attributes.varStruct.attributes.type")>
        <cfif attributes.varStruct.attributes.type EQ "WDDX">
          <cfset outputLine = "<cfwddx action=""CFML2WDDX"" input=""#attributes.varStruct#"" output=""#varStruct.attributes.name#"">">
          <cffile action="APPEND" 
                    file="#request.testHarness#" 
                  output="#outputLine#">
        </cfif>
      </cfif>
    </cfif>
  </cfcase>

  <cfcase value="handleSTRUCTURE">
    <!--- If it's an array (more than one <structure> tag), deal with each one individually --->
    <cfif IsArray(attributes.varStruct)>
      <cfloop from="1" to="#ArrayLen(attributes.varStruct)#" index="i">
        <cfset prefixToPass = "#attributes.namePrefix#">
        <cf_harness2 thisDir="#attributes.thisDir#"
                     verbose="#attributes.verbose#"
                       h2act="handleSTRUCTURE"
                   varStruct="#Duplicate(attributes.varStruct[i])#"
                  namePrefix="#prefixToPass#"
                    testFile="#request.testHarness#">
      </cfloop>
    <cfelse>
    <cfif attributes.namePrefix IS "">
      <cfif isdefined("attributes.varStruct.attributes.scope")>
      <cfset prefixToPass = attributes.varStruct.attributes.scope & ".">
    <cfelse>
      <cfset prefixToPass = "">
    </cfif>
    <cfelse>
      <cfset prefixToPass = "#attributes.namePrefix#">
    </cfif>
  
      <!--- Write structNew line --->
      <cfset outputLine = "<cfset #prefixToPass##attributes.varStruct.attributes.name# = StructNew()>">
      <cffile action="APPEND" 
                file="#request.testHarness#" 
              output="#outputLine#">
      <cfset prefixToPass = "#prefixToPass##attributes.varStruct.attributes.name#.">
      <!--- Loop over structure --->
      <cfloop collection="#attributes.varStruct#" item="thisLine">
        <cfif ListFindNoCase(lstSimpleDataTypes,thisLine)>
        <!--- If simple, write line --->
          <cfif IsArray(attributes.varStruct[thisLine])>
            <cfloop from="1" to="#ArrayLen(attributes.varStruct[thisLine])#" index="i">
              <cf_harness2 thisDir="#attributes.thisDir#"
                           verbose="#attributes.verbose#"
                             h2act="write#thisLine#Line"
                         varStruct="#Duplicate(attributes.varStruct[thisLine][i])#"
                          testFile="#request.testHarness#"
                        namePrefix="#prefixToPass#"
                         >
            </cfloop>
          <cfelse>
            <cf_harness2 thisDir="#attributes.thisDir#"
                         verbose="#attributes.verbose#"
                           h2act="write#thisLine#Line"
                       varStruct="#Duplicate(attributes.varStruct[thisLine])#"
                        testFile="#request.testHarness#"
                      namePrefix="#prefixToPass#"
                       >
          </cfif>
        <cfelseif ListFindNoCase(lstComplexDataTypes,thisLine)>
        <!--- If complex, recurse --->
          <cf_harness2 thisDir="#attributes.thisDir#"
                       verbose="#attributes.verbose#"
                         h2act="handle#thisLine#"
                     varStruct="#Duplicate(attributes.varStruct[thisLine])#"
                    nameprefix="#prefixToPass#"
                      testFile="#request.testHarness#">
        <cfelse>
          <cfif not ListFindNoCase(lstIgnoreTypes,thisLine)>
            Invalid data type in structure: #thisLine#<br>
          </cfif>
        </cfif>
      </cfloop>
      <!--- If WDDX, write serialize line --->
      <cfif IsDefined("attributes.varStruct.attributes.type")>
        <cfif attributes.varStruct.attributes.type EQ "WDDX">
          <cfset outputLine = "<cfwddx action=""CFML2WDDX"" input=""#attributes.varStruct#"" output=""#varStruct.attributes.name#"">">
          <cffile action="APPEND" 
                    file="#request.testHarness#" 
                  output="#outputLine#">
        </cfif>
      </cfif>
    </cfif>
  </cfcase>
  
  <cfcase value="handleRECORDSET">
    <!--- Collect the names of all children --->
    <cfset lstFieldNames = "">
    <cfloop collection="#attributes.varStruct#" item="thisField">
      <cfif ListFindNoCase(lstSimpleDataTypes,thisField)>
        <cfif IsArray(attributes.varStruct[thisField])>
          <cfloop from="1" to="#ArrayLen(attributes.varStruct[thisField])#" index="i">
            <cfset lstFieldNames = ListAppend(lstFieldNames,attributes.varStruct[thisField][i].Attributes.name)>
          </cfloop>
        <cfelse>
          <cfset lstFieldNames = ListAppend(lstFieldNames,attributes.varStruct[thisField].Attributes.name)>
        </cfif>
      </cfif>
    </cfloop>
    <cfif attributes.namePrefix IS "">
    <cfif isdefined("attributes.varStruct.attributes.scope")>
    <cfset prefixToPass = attributes.varStruct.attributes.scope & ".">
    <cfelse>
    <cfset prefixToPass = "">
    </cfif>
  <cfelse>
    <cfset prefixToPass = "#attributes.namePrefix#">
  </cfif>
  
    <!--- Write querySim opening tag --->
    <cfset outputLine = "<cf_querysim>#crlf##prefixToPass##attributes.varStruct.attributes.name##crlf##lstFieldNames#">
    <cffile action="APPEND" 
              file="#request.testHarness#" 
            output="#outputLine#">
    <!--- Loop over structure --->
  
    <cfloop collection="#attributes.varStruct#" item="thisLine">
      <cfif ListFindNoCase(lstSimpleDataTypes,thisLine)>
      <!--- If simple, write line --->
        <cfif IsArray(attributes.varStruct[thisLine])>
          <cfloop from="1" to="#ArrayLen(attributes.varStruct[thisLine])#" index="i">
            <cf_harness2 thisDir="#attributes.thisDir#"
                         verbose="#attributes.verbose#"
                           h2act="write#thisLine#Line"
                       varStruct="#Duplicate(attributes.varStruct[thisLine][i])#"
            namePrefix="#prefixToPass#"
                        testFile="#request.testHarness#"
                       lineStyle="querysim">
          </cfloop>
        <cfelse>
          <cf_harness2 thisDir="#attributes.thisDir#"
                       verbose="#attributes.verbose#"
                         h2act="write#thisLine#Line"
                     varStruct="#Duplicate(attributes.varStruct[thisLine])#"
          namePrefix="#prefixToPass#"
                      testFile="#request.testHarness#"
                     lineStyle="querysim">
        </cfif>
      <cfelseif ListFindNoCase(lstComplexDataTypes,thisLine)>
      <!--- If complex, recurse --->
        <cf_harness2 thisDir="#attributes.thisDir#"
                     verbose="#attributes.verbose#"
                       h2act="handle#thisLine#"
                   varStruct="#Duplicate(attributes.varStruct[thisLine])#"
          namePrefix="#prefixToPass#"
                    testFile="#request.testHarness#"
                   lineStyle="querysim">
      <cfelse>
        <cfif not ListFindNoCase(lstIgnoreTypes,thisLine)>
          Invalid data type in recordset: #thisLine#<br>
        </cfif>
      </cfif>
    </cfloop>
    <cfset outputLine = "#crlf#</cf_querysim>#crlf#">
    <cffile action="APPEND" 
              file="#request.testHarness#" 
            output="#outputLine#">
    <!--- If WDDX, write serialize line --->
    <cfif IsDefined("attributes.varStruct.attributes.type")>
      <cfif attributes.varStruct.attributes.type EQ "WDDX">
        <cfset outputLine = "<cfwddx action=""CFML2WDDX"" input=""#attributes.varStruct#"" output=""#varStruct.attributes.name#"">">
        <cffile action="APPEND" 
                  file="#request.testHarness#" 
                output="#outputLine#">
      </cfif>
    </cfif>
  </cfcase>
  
  <cfcase value="writeSTRINGLine">
    <!--- If it's an array of <string> tags, strip out the members --->
    <cfif IsArray(attributes.varStruct)>
      <cfloop from="1" to="#ArrayLen(attributes.varStruct)#" index="i">
      <cfset thiselement = attributes.varStruct[i]>
        <cfif attributes.lineStyle EQ "querysim">
          <cfset outputLine = "#attributes.varStruct[i].attributes.name#|">
          <cffile action="APPEND" 
                    file="#request.testHarness#" 
                  output="#outputLine#"
              addnewline="no">
        <cfelse>
      <cfif NOT isDefined("attributes.varStruct.attributes.name") OR attributes.linestyle EQ "array">
      <cfset attributes.varStruct.attributes.name = "">
      </cfif>
      <cfif attributes.namePrefix IS "" AND isDefined("thiselement.attributes.scope")>
      <cfset outputLine = "<cfset #thiselement.attributes.scope#.#thiselement.attributes.name#=""#thiselement.attributes.name#"">">
      <cfelse>
      <cfset outputLine = "<cfset #attributes.namePrefix##thiselement.attributes.name#=""#thiselement.attributes.name#"">">
      </cfif>
          
          <cffile action="APPEND" 
                    file="#request.testHarness#" 
                  output="#outputLine#">
        </cfif>
      </cfloop>
    <cfelse>
      <cfif attributes.lineStyle EQ "querysim">
        <cfset outputLine = "#attributes.varStruct.attributes.name#|">
        <cffile action="APPEND" 
                  file="#request.testHarness#" 
                output="#outputLine#"
            addnewline="no">
      <cfelse>
      <cfif NOT isDefined("attributes.varStruct.attributes.name") OR attributes.linestyle EQ "array">
      <cfset attributes.varStruct.attributes.name = "">
    </cfif>
      <cfif attributes.namePrefix IS "" AND isDefined("attributes.varStruct.attributes.scope")>
          <cfset outputLine = "<cfset #attributes.varStruct.attributes.scope#.#attributes.varStruct.attributes.name#=""#attributes.varStruct.attributes.name#data"">">
        <cfelse>
      <cfset outputLine = "<cfset #attributes.namePrefix##attributes.varStruct.attributes.name#=""#attributes.varStruct.attributes.name#data"">">
    </cfif>
    <cffile action="APPEND" 
                  file="#request.testHarness#" 
                output="#outputLine#">
      </cfif>
    </cfif>
  </cfcase>
  
  <cfcase value="writeNUMBERLine">
    <!--- If it's an array of <string> tags, strip out the members --->
    <cfif IsArray(attributes.varStruct)>
      <cfloop from="1" to="#ArrayLen(attributes.varStruct)#" index="i">
    <cfset thiselement = attributes.varStruct[i]>
        <cfif attributes.lineStyle EQ "querysim">
          <cfset outputLine = "1|">
          <cffile action="APPEND" 
                    file="#request.testHarness#" 
                  output="#outputLine#"
              addnewline="no">
        <cfelse>
      <cfif NOT isDefined("attributes.varStruct.attributes.name") OR attributes.linestyle EQ "array">
      <cfset attributes.varStruct.attributes.name = "">
      </cfif>
      <cfif attributes.namePrefix IS "" AND isDefined("thiselement.attributes.scope")>
        <cfset outputLine = "<cfset #thiselement.attributes.scope#.#attributes.varStruct[i].attributes.name#=1>">
      <cfelse>
      <cfset outputLine = "<cfset #attributes.namePrefix##attributes.varStruct[i].attributes.name#=1>">
      </cfif>
          <cffile action="APPEND" 
                    file="#request.testHarness#" 
                  output="#outputLine#">
        </cfif>
      </cfloop>
    <cfelse>
      <cfif attributes.lineStyle EQ "querysim">
        <cfset outputLine = "1|">
        <cffile action="APPEND" 
                  file="#request.testHarness#" 
                output="#outputLine#"
            addnewline="no">
      <cfelse>
      <cfif NOT isDefined("attributes.varStruct.attributes.name") OR attributes.linestyle EQ "array">
      <cfset attributes.varStruct.attributes.name = "">
    </cfif>
      <cfif attributes.namePrefix IS "" AND isDefined("attributes.varStruct.attributes.scope")>
        <cfset outputLine = "<cfset #attributes.varStruct.attributes.scope#.#attributes.varStruct.attributes.name#=1>">
    <cfelse>
      <cfset outputLine = "<cfset #attributes.namePrefix##attributes.varStruct.attributes.name#=1>">
    </cfif>
        <cffile action="APPEND" 
                  file="#request.testHarness#" 
                output="#outputLine#">
      </cfif>
    </cfif>
  </cfcase>

  <cfcase value="writeDATETIMELine">
    <cfif IsArray(attributes.varStruct)>
      <cfloop from="1" to="#ArrayLen(attributes.varStruct)#" index="i">
    <cfset thiselement = attributes.varStruct[i]>
        <cfif attributes.lineStyle EQ "querysim">
          <cfset outputLine = "#CreateDate(2003,1,1)#|">
          <cffile action="APPEND" 
                    file="#request.testHarness#" 
                  output="#outputLine#"
              addnewline="no">
        <cfelse>
      <cfif NOT isDefined("attributes.varStruct.attributes.name") OR attributes.linestyle EQ "array">
      <cfset attributes.varStruct.attributes.name = "">
      </cfif>
      <cfif attributes.namePrefix IS "" AND isDefined("thiselement.attributes.scope")>
        <cfset outputLine = "<cfset #thiselement.attributes.scope#.#attributes.varStruct[i].attributes.name#=CreateDate(2003,01,01)>">
      <cfelse>
      <cfset outputLine = "<cfset #attributes.namePrefix##attributes.varStruct[i].attributes.name#=CreateDate(2003,01,01)>">
      </cfif>
          <cffile action="APPEND" 
                    file="#request.testHarness#" 
                  output="#outputLine#">
        </cfif>
      </cfloop>
    <cfelse>
      <cfif attributes.lineStyle EQ "querysim">
        <cfset outputLine = "#CreateDate(2003,1,1)#|">
        <cffile action="APPEND" 
                  file="#request.testHarness#" 
                output="#outputLine#"
            addnewline="no">
      <cfelse>
    <cfif NOT isDefined("attributes.varStruct.attributes.name") OR attributes.linestyle EQ "array">
      <cfset attributes.varStruct.attributes.name = "">
    </cfif>
    <cfif attributes.namePrefix IS "" AND isDefined("attributes.varStruct.attributes.scope")>
        <cfset outputLine = "<cfset #attributes.varStruct.attributes.scope#.#attributes.varStruct.attributes.name#=CreateDate(2003,01,01)>">
    <cfelse>
      <cfset outputLine = "<cfset #attributes.namePrefix##attributes.varStruct.attributes.name#=CreateDate(2003,01,01)>">
    </cfif>
        <cffile action="APPEND" 
                  file="#request.testHarness#" 
                output="#outputLine#">
      </cfif>
    </cfif>
  </cfcase>

  <cfcase value="writeBOOLEANLine">
    <cfif IsArray(attributes.varStruct)>
      <cfloop from="1" to="#ArrayLen(attributes.varStruct)#" index="i">
        <cfset thiselement = attributes.varStruct[i]>
    <cfif attributes.lineStyle EQ "querysim">
          <cfset outputLine = "True|">
          <cffile action="APPEND" 
                    file="#request.testHarness#" 
                  output="#outputLine#"
              addnewline="no">
        <cfelse>
      <cfif NOT isDefined("attributes.varStruct.attributes.name") OR attributes.linestyle EQ "array">
      <cfset attributes.varStruct.attributes.name = "">
      </cfif>
          <cfif attributes.namePrefix IS "" AND isDefined("thiselement.attributes.scope")>
        <cfset outputLine = "<cfset #thiselement.attributes.scope#.#attributes.varStruct[i].attributes.name#=True>">
      <cfelse>
      <cfset outputLine = "<cfset #attributes.namePrefix##attributes.varStruct[i].attributes.name#=True>">
      </cfif>
          <cffile action="APPEND" 
                    file="#request.testHarness#" 
                  output="#outputLine#">
        </cfif>
      </cfloop>
    <cfelse>
      <cfif attributes.lineStyle EQ "querysim">
        <cfset outputLine = "True|">
        <cffile action="APPEND" 
                  file="#request.testHarness#" 
                output="#outputLine#"
            addnewline="no">
      <cfelse>
      <cfif NOT isDefined("attributes.varStruct.attributes.name") OR attributes.linestyle EQ "array">
      <cfset attributes.varStruct.attributes.name = "">
    </cfif>
    <cfif attributes.namePrefix IS "" AND isDefined("attributes.varStruct.attributes.scope")>
        <cfset outputLine = "<cfset #attributes.varStruct.attributes.scope#.#attributes.varStruct.attributes.name#=True>">
    <cfelse>
      <cfset outputLine = "<cfset #attributes.namePrefix##attributes.varStruct.attributes.name#=True>">
    </cfif>
        <cffile action="APPEND" 
                  file="#request.testHarness#" 
                output="#outputLine#">
      </cfif>
    </cfif>
  </cfcase>

  <cfcase value="writeLISTLine">
    <cfif IsArray(attributes.varStruct)>
      <cfloop from="1" to="#ArrayLen(attributes.varStruct)#" index="i">
        <cfset thiselement = attributes.varStruct[i]>
    <cfif attributes.lineStyle EQ "querysim">
          <cfset outputLine = "One,Two,Three|">
          <cffile action="APPEND" 
                    file="#request.testHarness#" 
                  output="#outputLine#"
              addnewline="no">
        <cfelse>
      <cfif NOT isDefined("attributes.varStruct.attributes.name") OR attributes.linestyle EQ "array">
      <cfset attributes.varStruct.attributes.name = "">
      </cfif>
          <cfif attributes.namePrefix IS "" AND isDefined("thiselement.attributes.scope")>
        <cfset outputLine = "<cfset #thiselement.attributes.scope#.#attributes.varStruct[i].attributes.name#=""1,2,3"">">
      <cfelse>
      <cfset outputLine = "<cfset #attributes.namePrefix##attributes.varStruct[i].attributes.name#=""1,2,3"">">
      </cfif>
          <cffile action="APPEND" 
                    file="#request.testHarness#" 
                  output="#outputLine#">
        </cfif>
      </cfloop>
    <cfelse>  
      <cfif attributes.lineStyle EQ "querysim">
        <cfset outputLine = "One,Two,Three|">
        <cffile action="APPEND" 
                  file="#request.testHarness#" 
                output="#outputLine#"
            addnewline="no">
      <cfelse>
      <cfif NOT isDefined("attributes.varStruct.attributes.name") OR attributes.linestyle EQ "array">
      <cfset attributes.varStruct.attributes.name = "">
    </cfif>
        <cfif attributes.namePrefix IS "" AND isDefined("attributes.varStruct.attributes.scope")>
        <cfset outputLine = "<cfset #attributes.varStruct.attributes.scope#.#attributes.varStruct.attributes.name#=""1,2,3"">">
    <cfelse>
      <cfset outputLine = "<cfset #attributes.namePrefix##attributes.varStruct.attributes.name#=""1,2,3"">">
    </cfif>
        <cffile action="APPEND" 
                  file="#request.testHarness#" 
                output="#outputLine#">
      </cfif>
    </cfif>
  </cfcase>

  <cfcase value="writeCOOKIELine">
    <cfif IsArray(attributes.varStruct)>
      <cfloop from="1" to="#ArrayLen(attributes.varStruct)#" index="i">
        <cfset outputLine = "<cfset cookie.#attributes.varStruct[i].attributes.name#=""#thisLine#"">">
        <cffile action="APPEND" 
                  file="#request.testHarness#" 
                output="#outputLine#">
      </cfloop>
    <cfelse>
      <cfset outputLine = "<cfset cookie.#attributes.varStruct.attributes.name#=""#thisLine#"">">
      <cffile action="APPEND" 
                file="#request.testHarness#" 
              output="#outputLine#">
    </cfif>
  </cfcase>

  <cfdefaultcase>
    I don't have a handler for #attributes.h2act#.<br>
  </cfdefaultcase>
</cfswitch>

</cfoutput>
</cfif>
