<cfsilent>
<!--- fusebox40.parser.cfmx.cfm --->

<!---
Fusebox Software License
Version 1.0

Copyright (c) 2003 The Fusebox Corporation. All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

1. Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

2. Redistributions in binary form or otherwise encrypted form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

3. The end-user documentation included with the redistribution, if any, must include the following acknowledgment:

"This product includes software developed by the Fusebox Corporation (http://www.fusebox.org/)."

Alternately, this acknowledgment may appear in the software itself, if and wherever such third-party acknowledgments normally appear.

4. The names "Fusebox" and "Fusebox Corporation" must not be used to endorse or promote products derived from this software without prior written (non-electronic) permission. For written permission, please contact fusebox@fusebox.org.

5. Products derived from this software may not be called "Fusebox", nor may "Fusebox" appear in their name, without prior written (non-electronic) permission of the Fusebox Corporation. For written permission, please contact fusebox@fusebox.org.

If one or more of the above conditions are violated, then this license is immediately revoked and can be re-instated only upon prior written authorization of the Fusebox Corporation.

THIS SOFTWARE IS PROVIDED "AS IS" AND ANY EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE FUSEBOX CORPORATION OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

-------------------------------------------------------------------------------

This software consists of voluntary contributions made by many individuals on behalf of the Fusebox Corporation. For more information on Fusebox, please see <http://www.fusebox.org/>.

--->

<cfscript>
  // which version of the parser is this?
  myFusebox.version.parser = "4.0.3";
  
  // prepare to create the fuseaction file
  fb_.parsedfile = "";
  fb_.CRLF = CHR(10);
  
  // this variable tracks the current level of indentation
  fb_.indentLevel = 0;
  fb_.indentBlock = chr(9);
  // we'll just assume that no one is going to look at a parse file with
  // more than 1000 levels of indentation.
  fb_.maxIndentLevel = iif(application.fusebox.parseWithIndentation, 1000, 0);
  
  // cut down on white space a bit
  fb_.parsedfile = fb_.parsedfile & repeatString(fb_.indentBlock, min(fb_.maxIndentLevel, fb_.indentLevel)) & '<cfsetting enablecfoutputonly="Yes">' & fb_.CRLF;

  // set the character encoding for this file
  fb_.parsedfile = fb_.parsedfile & repeatString(fb_.indentBlock, min(fb_.maxIndentLevel, fb_.indentLevel)) & '<cfprocessingdirective pageencoding="#application.fusebox.characterEncoding#">' & fb_.CRLF;
  
  // if any plugins were defined for the processError phase then insert an opening tag for <cftry> here
  if (arrayLen(application.fusebox.pluginphases['processError']) GT 0) {
    fb_.parsedfile = fb_.parsedfile & repeatString(fb_.indentBlock, min(fb_.maxIndentLevel, fb_.indentLevel)) & "<cftry>" & fb_.CRLF;
  }
</cfscript>

<!--- now parse the Fusebox XML grammar --->
<cfloop from="1" to="#arrayLen(fb_.fuseQ)#" index="fb_.i">
  <cfscript>
    if (application.fusebox.parseWithComments) {
      fb_.parsedfile = fb_.parsedfile & repeatString(fb_.indentBlock, min(fb_.maxIndentLevel, fb_.indentLevel)) & '<!--- ' & ljustify('generated by fuseQ[#fb_.i#] verb: #ucase(fb_.fuseQ[fb_.i].xmlName)# via #fb_.fuseQ[fb_.i].circuit#.#fb_.fuseQ[fb_.i].fuseaction#' , 75) & ' --->';
      fb_.parsedfile = fb_.parsedfile & fb_.CRLF;
    }
  </cfscript>
	
	<cfswitch expression="#fb_.fuseQ[fb_.i].xmlName#">

		<cfcase value="set,xfa">
      <cfscript>
		// if no "name" attribute is passed in then set a throw-away variable in the "fb_" structure as the "name" attribute
		// note: this effectively converts an <xfa> to a <set>
		if ( NOT StructKeyExists(fb_.fuseQ[fb_.i].xmlAttributes, "name") OR NOT Len( fb_.fuseQ[fb_.i].xmlAttributes.name) ) {
			fb_.fuseQ[fb_.i].xmlName = "set";
			fb_.fuseQ[fb_.i].xmlAttributes.name = "fb_['#CreateUUID()#']";
		}
	  	// bit of massaging if this is the <xfa> verb
	  	if (fb_.fuseQ[fb_.i].xmlName EQ "xfa") {
			//prepend "xfa." to the value of the "name" attribute
			fb_.fuseQ[fb_.i].xmlAttributes.name = "xfa." & fb_.fuseQ[fb_.i].xmlAttributes.name;
			//assume no circuit specified means the current circuit
			if (ListLen(fb_.fuseQ[fb_.i].xmlAttributes.value, '.') LTE 1) {
				fb_.fuseQ[fb_.i].xmlAttributes.value = fb_.fuseQ[fb_.i].circuit & '.' & fb_.fuseQ[fb_.i].xmlAttributes.value;
			}
		}
	  	// if the attribute 'overwrite' is FALSE then treat this like a CFPARAM
        if (StructKeyExists(fb_.fuseQ[fb_.i].xmlAttributes, "overwrite") AND NOT fb_.fuseQ[fb_.i].xmlAttributes.overwrite) {
          fb_.parsedfile = fb_.parsedfile & repeatString(fb_.indentBlock, min(fb_.maxIndentLevel, fb_.indentLevel)) & '<cfif NOT IsDefined("' & fb_.fuseQ[fb_.i].xmlAttributes.name & '")>';
		  fb_.indentLevel = fb_.indentLevel + 1;
        }
		  // if the 'name' attribute has any pound ( that is, chr(35) )signs in it, we'll need double quotes to evaluate the dynamic variable name
		  fb_.parsedfile = fb_.parsedfile & repeatString(fb_.indentBlock, min(fb_.maxIndentLevel, fb_.indentLevel)) & '<cfset ';
		  if ( FindNoCase( chr(35) , fb_.fuseQ[fb_.i].xmlAttributes.name ) ) {
	        fb_.parsedfile = fb_.parsedfile & '"#fb_.fuseQ[fb_.i].xmlAttributes.name#"';	  
		  }
		  else {
	        fb_.parsedfile = fb_.parsedfile & '#fb_.fuseQ[fb_.i].xmlAttributes.name#';
   	  }
		  fb_.parsedfile = fb_.parsedfile & ' = ';     
        // if the attributes 'evaluate' is TRUE the use the evaluate function
        if (StructKeyExists(fb_.fuseQ[fb_.i].xmlAttributes, "evaluate") AND fb_.fuseQ[fb_.i].xmlAttributes.evaluate) {
          fb_.parsedfile = fb_.parsedfile & 'Evaluate("' &  fb_.fuseQ[fb_.i].xmlAttributes.value & '")>';
        }
        else {
          fb_.parsedfile = fb_.parsedfile & '"' &  fb_.fuseQ[fb_.i].xmlAttributes.value & '">';
        }
	  	// if the attribute 'overwrite' is FALSE then treat this like a CFPARAM
        if (StructKeyExists(fb_.fuseQ[fb_.i].xmlAttributes, "overwrite") AND NOT fb_.fuseQ[fb_.i].xmlAttributes.overwrite) {
		  fb_.indentLevel = fb_.indentLevel - 1;
          fb_.parsedfile = fb_.parsedfile & repeatString(fb_.indentBlock, min(fb_.maxIndentLevel, fb_.indentLevel)) & '</cfif>';
        }
      </cfscript>
		</cfcase>

		<cfcase value="include">
      <cfscript>
        fb_.template = fb_.fuseQ[fb_.i].xmlAttributes.template;
        fb_.templateDelimiter = ListLast(fb_.template, '.');
        if (NOT ( ListFindNoCase(application.fusebox.maskedFileDelimiters, fb_.templateDelimiter, ',') OR
                  ListFindNoCase(application.fusebox.maskedFileDelimiters, '*', ',') )) {
          fb_.template = fb_.template & '.' & application.fusebox.scriptFileDelimiter;
        }
		  if ( NOT StructKeyExists(fb_.fuseQ[fb_.i].xmlAttributes, "required")) {
		  		StructInsert(fb_.fuseQ[fb_.i].xmlAttributes, "required", "true");
		  }
        if ( fb_.fuseQ[fb_.i].xmlAttributes['required'] IS TRUE) {
		  fb_.parsedfile = fb_.parsedfile & repeatString(fb_.indentBlock, min(fb_.maxIndentLevel, fb_.indentLevel)) & '<cftry>';
		  fb_.parsedfile = fb_.parsedfile & '<cfoutput><cfinclude template="' & application.fusebox.parseRootPath & application.fusebox.circuits[fb_.fuseQ[fb_.i].xmlAttributes.circuit].path & fb_.template & '"></cfoutput>';      
          fb_.parsedfile = fb_.parsedfile & '<cfcatch type="missingInclude"><cfif Right(cfcatch.missingFilename, len("#application.fusebox.circuits[fb_.fuseQ[fb_.i].xmlAttributes.circuit].path##fb_.template#") ) EQ "#application.fusebox.circuits[fb_.fuseQ[fb_.i].xmlAttributes.circuit].path##fb_.template#"><cfthrow type="fusebox.missingFuse" message="missing Fuse" detail="You tried to include a fuse #fb_.fuseQ[fb_.i].xmlAttributes.template# in circuit #fb_.fuseQ[fb_.i].xmlAttributes.circuit# which does not exist."><cfelse><cfrethrow></cfif></cfcatch>';
		  fb_.parsedfile = fb_.parsedfile & '</cftry>';		  
        }
        else {
		  fb_.parsedfile = fb_.parsedfile & repeatString(fb_.indentBlock, min(fb_.maxIndentLevel, fb_.indentLevel)) & '<cftry>';
          fb_.parsedfile = fb_.parsedfile & '<cfoutput><cfinclude template="' & application.fusebox.parseRootPath & application.fusebox.circuits[fb_.fuseQ[fb_.i].xmlAttributes.circuit].path & fb_.template & '"></cfoutput>';
          fb_.parsedfile = fb_.parsedfile & '<cfcatch type="missingInclude"><cfif Right(cfcatch.missingFilename, len("#application.fusebox.circuits[fb_.fuseQ[fb_.i].xmlAttributes.circuit].path##fb_.template#") ) EQ "#application.fusebox.circuits[fb_.fuseQ[fb_.i].xmlAttributes.circuit].path##fb_.template#"><!--- do nothing ---><cfelse><cfrethrow></cfif></cfcatch>';
          fb_.parsedfile = fb_.parsedfile & '</cftry>';         
        }
      </cfscript>
		</cfcase>
		
		<cfcase value="plugin">
      <cfscript>
        fb_.template = fb_.fuseQ[fb_.i].plugin.template;
        fb_.templateDelimiter = ListLast(fb_.template, '.');
        if (NOT ( ListFindNoCase(application.fusebox.maskedFileDelimiters, fb_.templateDelimiter, ',') OR
                  ListFindNoCase(application.fusebox.maskedFileDelimiters, '*', ',') )) {
          fb_.template = fb_.template & '.' & application.fusebox.scriptFileDelimiter;
        }
        fb_.parsedfile = fb_.parsedfile & repeatString(fb_.indentBlock, min(fb_.maxIndentLevel, fb_.indentLevel)) & '<cfset myFusebox.thisPlugin  = "' & fb_.fuseQ[fb_.i].plugin.name & '">' & fb_.CRLF;
        fb_.parsedfile = fb_.parsedfile & repeatString(fb_.indentBlock, min(fb_.maxIndentLevel, fb_.indentLevel)) & '<cfset myFusebox.thisPhase  = "' & fb_.fuseQ[fb_.i].phase & '">' & fb_.CRLF;
        fb_.parsedfile = fb_.parsedfile & repeatString(fb_.indentBlock, min(fb_.maxIndentLevel, fb_.indentLevel)) & '<cfoutput><cfinclude template="' & application.fusebox.parseRootPath & REreplace(fb_.fuseQ[fb_.i].plugin.path, "\\/", application.fusebox.osdelimiter, "all") & REreplace(fb_.template, "\\/", application.fusebox.osdelimiter, "all") & '"></cfoutput>';
      </cfscript>
		</cfcase>

		<cfcase value="errorHandler,exceptionHandler">
<!---
			<cfset fb_.parsedfile = fb_.parsedfile & '<cfset myFusebox.thisPlugin  = "' & fb_.fuseQ[fb_.i].plugin.name & '">' & fb_.CRLF>
			<cfset fb_.parsedfile = fb_.parsedfile & '<cfset myFusebox.thisPhase  = "' & fb_.fuseQ[fb_.i].phase & '">' & fb_.CRLF>
			<cfset fb_.parsedfile = fb_.parsedfile & '<cfset myFusebox.thisCircuit = "' & fb_.fuseQ[fb_.i].circuit & '">' & fb_.CRLF>
			<cfset fb_.parsedfile = fb_.parsedfile & '<cfset myFusebox.thisFuseaction = "' & fb_.fuseQ[fb_.i].fuseaction & '">' & fb_.CRLF>
--->
			<cfset fb_.handlerfile = application.fusebox.rootdirectory & REreplace(fb_.fuseQ[fb_.i].plugin.path, "\\/", application.fusebox.osdelimiter, "all") & REreplace(fb_.fuseQ[fb_.i].plugin.template, "\\/", application.fusebox.osdelimiter, "all")>
			
      		<cffile action="read" file="#fb_.handlerfile#" variable="fb_.handlerfile" charset="#application.fusebox.characterEncoding#">
			<cfset fb_.handlerfile = repeatString(fb_.indentBlock, min(fb_.maxIndentLevel, fb_.indentLevel)) & REreplace(fb_.handlerfile, "([#chr(10)##chr(13)#])", "\1" & repeatString(fb_.indentBlock, min(fb_.maxIndentLevel, fb_.indentLevel)), "all") />
			<cfset fb_.parsedfile = fb_.parsedfile & fb_.CRLF & fb_.handlerfile>
		</cfcase>
		
		<cfcase value="beginExceptionHandler">
			<cfset fb_.parsedfile = fb_.parsedfile & repeatString(fb_.indentBlock, min(fb_.maxIndentLevel, fb_.indentLevel)) & "<cftry>">
			<cfset fb_.indentLevel = fb_.indentLevel + 1 />
		</cfcase>
		
		<cfcase value="endExceptionHandler">
			<cfset fb_.indentLevel = fb_.indentLevel - 1 />
			<cfset fb_.parsedfile = fb_.parsedfile & repeatString(fb_.indentBlock, min(fb_.maxIndentLevel, fb_.indentLevel)) & "</cftry>">
		</cfcase>

		<cfcase value="conditional">
      <cfscript>
        if (StructKeyExists(fb_.fuseQ[fb_.i].xmlAttributes, "mode")) {
          if (fb_.fuseQ[fb_.i].xmlAttributes['mode'] EQ "begin") {
            fb_.parsedfile = fb_.parsedfile & repeatString(fb_.indentBlock, min(fb_.maxIndentLevel, fb_.indentLevel)) & "<cfif " & fb_.fuseQ[fb_.i].xmlAttributes['condition'] & ">";
		  	fb_.indentLevel = fb_.indentLevel + 1;
          }
          else if (fb_.fuseQ[fb_.i].xmlAttributes['mode'] EQ "else") {
		  	fb_.indentLevel = fb_.indentLevel - 1;
            fb_.parsedfile = fb_.parsedfile & repeatString(fb_.indentBlock, min(fb_.maxIndentLevel, fb_.indentLevel)) & "<cfelse>";
		  	fb_.indentLevel = fb_.indentLevel + 1;
          }
          else if (fb_.fuseQ[fb_.i].xmlAttributes['mode'] EQ "end") {
		  	fb_.indentLevel = fb_.indentLevel - 1;
            fb_.parsedfile = fb_.parsedfile & repeatString(fb_.indentBlock, min(fb_.maxIndentLevel, fb_.indentLevel)) & "</cfif>";
          }
        }
      </cfscript>
		</cfcase>
		
		<cfcase value="loop">
      <cfscript>
        if (StructKeyExists(fb_.fuseQ[fb_.i].xmlAttributes, "mode")) {
          if (fb_.fuseQ[fb_.i].xmlAttributes['mode'] EQ "begin") {
            fb_.parsedfile = fb_.parsedfile & repeatString(fb_.indentBlock, min(fb_.maxIndentLevel, fb_.indentLevel)) & '<cfloop condition="' & fb_.fuseQ[fb_.i].xmlAttributes['condition'] & '">';
		  	fb_.indentLevel = fb_.indentLevel + 1;
          }
          else if (fb_.fuseQ[fb_.i].xmlAttributes['mode'] EQ "end") {
		  	fb_.indentLevel = fb_.indentLevel - 1;
            fb_.parsedfile = fb_.parsedfile & repeatString(fb_.indentBlock, min(fb_.maxIndentLevel, fb_.indentLevel)) & "</cfloop>";
          }
        }        
      </cfscript>
		</cfcase>

		<cfcase value="contentvariable">
      <cfscript>
        if (StructKeyExists(fb_.fuseQ[fb_.i].xmlAttributes, "mode")) {
          if (fb_.fuseQ[fb_.i].xmlAttributes['mode'] EQ "begin") {
            if (fb_.fuseQ[fb_.i].xmlAttributes.overwrite EQ "false") {
              fb_.parsedfile = fb_.parsedfile & repeatString(fb_.indentBlock, min(fb_.maxIndentLevel, fb_.indentLevel)) & '<cfif NOT isDefined("' & fb_.fuseQ[fb_.i].xmlAttributes['contentvariable'] & '")>';
           	  fb_.indentLevel = fb_.indentLevel + 1;
            }
            fb_.parsedfile = fb_.parsedfile & repeatString(fb_.indentBlock, min(fb_.maxIndentLevel, fb_.indentLevel)) & '<cfsavecontent variable="' & fb_.fuseQ[fb_.i].xmlAttributes['contentvariable'] & '">';
            fb_.indentLevel = fb_.indentLevel + 1;
            if (fb_.fuseQ[fb_.i].xmlAttributes.append EQ "true") {
              fb_.parsedfile = fb_.parsedfile & fb_.CRLF & repeatString(fb_.indentBlock, min(fb_.maxIndentLevel, fb_.indentLevel)) & '<cfparam name="'& fb_.fuseQ[fb_.i].xmlAttributes['contentvariable'] & '" default="">';
              fb_.parsedfile = fb_.parsedfile & fb_.CRLF & repeatString(fb_.indentBlock, min(fb_.maxIndentLevel, fb_.indentLevel)) & '<cfoutput>##' & fb_.fuseQ[fb_.i].xmlAttributes['contentvariable'] & '##</cfoutput>';
            }
          }
          else {
		    fb_.indentLevel = fb_.indentLevel - 1;	
            fb_.parsedfile = fb_.parsedfile & repeatString(fb_.indentBlock, min(fb_.maxIndentLevel, fb_.indentLevel)) & '</cfsavecontent>';
            if (NOT fb_.fuseQ[fb_.i].xmlAttributes.overwrite) {
			  fb_.indentLevel = fb_.indentLevel - 1;
              fb_.parsedfile = fb_.parsedfile & repeatString(fb_.indentBlock, min(fb_.maxIndentLevel, fb_.indentLevel)) & '</cfif>';
            }
          }
        }
      </cfscript>
		</cfcase>
		
		<cfcase value="relocate">
      <cfscript>
        if (StructKeyExists(fb_.fuseQ[fb_.i].xmlAttributes, "addtoken") AND fb_.fuseQ[fb_.i].xmlAttributes['addtoken'] IS TRUE) {
          fb_.addtoken = 'addtoken="yes"';
        }
        else {
          fb_.addtoken = 'addtoken="no"';
        }
        if (StructKeyExists(fb_.fuseQ[fb_.i].xmlAttributes, "type") AND fb_.fuseQ[fb_.i].xmlAttributes['type'] EQ "server") {
          fb_.parsedfile = fb_.parsedfile & repeatString(fb_.indentBlock, min(fb_.maxIndentLevel, fb_.indentLevel)) & '<CFSCRIPT>getPageContext().forward("' & fb_.fuseQ[fb_.i].xmlAttributes.url & '");</CFSCRIPT>';
        }
        else {
          fb_.parsedfile = fb_.parsedfile & repeatString(fb_.indentBlock, min(fb_.maxIndentLevel, fb_.indentLevel)) & '<cflocation url="' & fb_.fuseQ[fb_.i].xmlAttributes.url & '" ' & fb_.addtoken & '>';
        }
   	  // add a cfabort after each relocate (server or client)
        fb_.parsedfile = fb_.parsedfile & fb_.CRLF & repeatString(fb_.indentBlock, min(fb_.maxIndentLevel, fb_.indentLevel)) & '<cfabort>';
      </cfscript>
		</cfcase>
		
		<cfcase value="create">
			<cfscript>
			fb_.parsedfile = fb_.parsedfile & "<cfset #fb_.fuseQ[fb_.i].xmlAttributes.object# = createObject('#fb_.fuseQ[fb_.i].xmlAttributes.type#', '#fb_.fuseQ[fb_.i].xmlAttributes.class#')>";
			</cfscript>
		</cfcase>
		
		<cfdefaultcase>
	      <cfscript>
	        if (application.fusebox.parseWithComments) {
	          fb_.parsedfile = fb_.parsedfile & repeatString(fb_.indentBlock, min(fb_.maxIndentLevel, fb_.indentLevel)) & '<!--- generated by fuseQ[#fb_.i#]  UNKNOWN VERB: #fb_.fuseQ[fb_.i].xmlName#  --->';
	        }
	      </cfscript>
			
			<cfif NOT application.fusebox.ignoreBadGrammar>
				<cfthrow type="fusebox.badGrammar" message="Bad Grammar construct in circuit file" detail="A bad grammar construct was encountered in the circuit '#fb_.fuseQ[fb_.i].circuit#' caused by the unknown or misspelled Fusebox grammar verb '#fb_.fuseQ[fb_.i].xmlName#'.">
			</cfif> 
		</cfdefaultcase>		
		
	</cfswitch>
	
	<cfset fb_.parsedfile = fb_.parsedfile & fb_.CRLF >
</cfloop>	

<cfscript>
  // if any plugins were defined for the processError phase then insert a closing tag for </cftry> here
  if (arrayLen(application.fusebox.pluginphases['processError']) GT 0) {
    fb_.parsedfile = fb_.parsedfile & repeatString(fb_.indentBlock, min(fb_.maxIndentLevel, fb_.indentLevel)) & "</cftry>" & fb_.CRLF;
  }
  fb_.parsedfile = fb_.parsedfile & fb_.CRLF & '<cfsetting enablecfoutputonly="No">';
</cfscript>

<!--- finished --->
</cfsilent>

