<!------------------------------------------------------------------
  Project: SOXML Demo
  Template: dsp_demo_soxml_cf2xmldom.cfm
  Author: Brett Suwyn
  Created: 10/18/2000
  Description: 

------------------------------------------------------------------->
<cfscript>

  // Im building this to mimic a typical query from a DB
  qSONewsFeed = QueryNew("Source,HeadLine,URL");
  
  QueryAddRow(qSONewsFeed);
  QuerySetCell(qSONewsFeed,"Source","PR Newswire");
  QuerySetCell(qSONewsFeed,"HeadLine","Methanex reports strong third quarter earnings of US$60.4 million");  
  QuerySetCell(qSONewsFeed,"URL",">http://www.prnewswire.com/cgi-bin/ind_display.pl?Account=OIL&amp;Template=worldoil.menu");     
  
  QueryAddRow(qSONewsFeed);
  QuerySetCell(qSONewsFeed,"Source","SiteObjects, Inc.");
  QuerySetCell(qSONewsFeed,"HeadLine","Site Objects Releases SOXML");  
  QuerySetCell(qSONewsFeed,"URL","http://www.siteobjects.com");    

  QueryAddRow(qSONewsFeed);
  QuerySetCell(qSONewsFeed,"Source","Yahoo");
  QuerySetCell(qSONewsFeed,"HeadLine","Allaire Reports Third Quarter 2000 Financial Results");  
  QuerySetCell(qSONewsFeed,"URL","http://biz.yahoo.com/prnews/001018/ma_allaire.html");      

  QueryAddRow(qSONewsFeed);
  QuerySetCell(qSONewsFeed,"Source","Excite");
  QuerySetCell(qSONewsFeed,"HeadLine","Sun Earnings Beat Expectations");  
  QuerySetCell(qSONewsFeed,"URL","http://news.excite.com/tech/");     
  
  QueryAddRow(qSONewsFeed);
  QuerySetCell(qSONewsFeed,"Source","PR Newswire");
  QuerySetCell(qSONewsFeed,"HeadLine","Smith International, Inc. Reports Quarterly Earnings of 41 Cents Per Share");  
  QuerySetCell(qSONewsFeed,"URL","http://www.prnewswire.com/cgi-bin/ind_display.pl?Account=OIL&amp;Template=worldoil.menu");     
   
  QueryAddRow(qSONewsFeed);
  QuerySetCell(qSONewsFeed,"Source","New York Times");
  QuerySetCell(qSONewsFeed,"HeadLine","AOL and Time Warner Meet Estimates");  
  QuerySetCell(qSONewsFeed,"URL","http://www.nytimes.com/auth/chk_login");     
  
  QueryAddRow(qSONewsFeed);
  QuerySetCell(qSONewsFeed,"Source","Forbes");
  QuerySetCell(qSONewsFeed,"HeadLine","Sun shares rise after earnings easily top estimates");  
  QuerySetCell(qSONewsFeed,"URL","http://www.forbes.com/");     

  QueryAddRow(qSONewsFeed);
  QuerySetCell(qSONewsFeed,"Source","PR Newswire");
  QuerySetCell(qSONewsFeed,"HeadLine","TECO Energy Reports Third Quarter Earnings Up 20 Percent");  
  QuerySetCell(qSONewsFeed,"URL","http://www.prnewswire.com/cgi-bin/ind_display.pl?Account=OIL&amp;Template=worldoil.menu");   
  
  /*
    Remember you can feed SOXML CF2XML any data type, not just a query.
    It will even handle nested datatypes.
    
  */  
</cfscript>
  
<!--- Lets load our query into a MSXML DOM Object --->
<cf_SOXML
  action="CF2XMLDOM"
  input="#qSONewsFeed#"
  output="oSONewsFeed"
  rootname="sonewsfeed">

<!--- Now we have a DOM object of the above query we can 
        output the entire XML document with SOXML xml2html  
        to see what we are working with --->
<h4>The output for the entire query transformed to XML</h4>
<cf_SOXML
  action="XML2HTML"
  input="#oSONewsFeed.xml#">        

  
<!--- Now lets do something a bit cooler than the CF2XML example
        Lets use XSL to grab all the articles matching a source of PR Newswire
        Sure this could be done in the query SQL but thats not the point :) 
        Since we used the action CF2XMLDOM we have the XML DOM 
        object and are ready to go --->
<cfscript>
  // Time to grab the PR Newswire nodes
  ndNewswire = oSONewsFeed.selectNodes("SONEWSFEED/ROW[SOURCE = 'PR Newswire']");
  // We now have a XMLDOMNodeList object
  // Lets loop through it and check it out!
</cfscript>        

<h4>HTML Output of just the PR Newswire news items</h4>

<cfloop collection="#ndNewswire#" item="idxNewswire">

  <!--- Lets just dump the nodes to html --->
  <cf_SOXML
    action="XML2HTML"
    input="#idxNewswire.xml#">

</cfloop>

<!--- Ok, sure thats all fun and games but what if we want to add a
        new news item.  Can it be done?  Sure!! --->
        
<cfscript>
  //First we need to create a empty node element
  ndNewNewsRow = oSONewsFeed.createNode(1,"ROW","");
  
  //Next we create a 3 node elements to hold our data
  ndNewNewsSource = oSONewsFeed.createNode(1,"SOURCE","");
  ndNewNewsHeadLine = oSONewsFeed.createNode(1,"HEADLINE","");
  ndNewNewsURL = oSONewsFeed.createNode(1,"URL","");    
  
  //Now lets add the data to the nodes
  ndNewNewsSource.Text = "Inline XML Editing";
  ndNewNewsHeadLine.Text = "Whoa!  It works, that wasn't so hard";
  ndNewNewsURL.Text = "http://www.siteobjects.com";
  
  //Now we need to merge the nodes together
  ndNewNewsRow.appendChild(ndNewNewsSource);
  ndNewNewsRow.appendChild(ndNewNewsHeadLine);
  ndNewNewsRow.appendChild(ndNewNewsURL);    
  
  //Last step is to add the ROW node to our master XML document
  ndSONewsRoot = oSONewsFeed.documentElement;
  ndSONewsRoot.appendChild(ndNewNewsRow);
</cfscript> 

<!--- Did it work?  Lets dump it to HTML and see --->
<h4>HTML Output of our new news item</h4>
<cf_SOXML
  action="XML2HTML"
  input="#ndNewNewsRow.xml#">
    
<h4>HTML Output of our new item added to the master XML document<br>
        Remember we appended it to the XML so open the last row to see it</h4>
        
<cf_SOXML
  action="XML2HTML"
  input="#ndSONewsRoot.xml#">
