<!------------------------------------------------------------------
  Project: SOXML Demo
  Template: dsp_demo_soxml_default.cfm
  Author: Brett Suwyn
  Created: 10/18/2000
  Description: 
    Default display file for SOXML demo app

------------------------------------------------------------------->

<table width="100%">
<tr>
<td>
<h1>SOXML v1.6</h1>
<h3>XML Interface for Allaire's ColdFusion</h3>
</td>
<td align="right" valign="top">
<a href="http://www.siteobjects.com" target="_new"><img src="http://www.siteobjects.com/images/siteobjects.gif" border="0"></a>
</td>
</tr>
</table>
<ul>
<li><a href="#readme">SOXML Documentation</a></li>
<li><a href="#cf2xml">CF2XML Example</a></li>
<li><a href="#cf2xmldom">CF2XMLDOM Example</a></li>
<li><a href="#xml2cf">XML2CF Example</a></li>
<li><a href="#xml2dom">XML2DOM Example</a></li>
<li><a href="#transform">Transform Example</a></li>
<li><a href="#xml2html">XML2HTML Example</a></li>
<li><a href="#references">References</a></li>
<li><a href="#support">Support</a></li>
<li><a href="soxml_useragreement.txt">User Agreement</a></li>
</ul>
<p />
<p />
<a name="readme" />
<h4><a href="soxml_readme.txt">SOXML_ReadMe.txt</a></h4>
<p>
Release notes and documentation included SOXML.
</p>
<h3>Examples</h3>
<a name="CF2XML" />
<h4><a href="<cfoutput>#CGI.Script_Name#</cfoutput>?action=cf2xml">CF2XML</a></h4>
<p>
The first example action of SOXML.  This is a very simple example that converts a CF query into XML.  The important aspect
of this example is to note how the XML is delivered via HTTP with the use of cfcontent.  If you were syndicating content or data in 
a pull scenario from a website this is how you would want to do it.<br>
We would also want to use CF2XML for simple XML conversion, where we will not need to modifiy or tinker with the XML DOM.  You would
use this action over CF2XMLDOM for the above scenario or if you were storing the XML in a database directly after the conversion.  Since
CF2XML does not use MSXML to transform the data it is a bit faster, and it will work on servers without MSXML installed.
</p>
<a name="CF2XMLDOM" />
<h4><a href="<cfoutput>#CGI.Script_Name#</cfoutput>?action=cf2xmldom">CF2XMLDOM</a></h4>
<p>
Ok enough fooling around, lets slap up some more XML.  This time we are going to load a little bit larger query into SOXML with
the action CF2XMLDOM so that we may play with the DOM a bit.  Here is the game plan.<br>  Step 1: Load the query
into a XML DOM object using CF2XMLDOM.  Output the entire XML document to HTML using XML2HTML.  Ok its loaded we can see it, good deal.<br>
Step 2: Now in the spirit of Emeril Lagasse lets step it up a notch and do something with this thing called the DOM.  Lets use a XPath expression and query the 
XML document for just the news items from the PR Newswire.  Bam! There it is. <br>Step 3: How about adding a new news item to the XML document?
Sure no problem.  Done.
</p>
<a name="XML2CF" />
<h4><a href="<cfoutput>#CGI.Script_Name#</cfoutput>?action=xml2cf">XML2CF</a></h4>
<p>
Our old tag, XMLParse is gone.  This action supercedes that tag, with a bit of modification for the better.  What this action will do is take a XML
string/URL/File as input and convert the document to a complex CF structure.  Be sure to download cf_ObjectDump from the tag gallery.  That tag
will dump the object created by XML2CF to HTML allowing you to find the data you need to grab.  With complex XML documents the structure can
get a bit thick, so some knowledge of nested datatypes is a plus.  In this example we will load the file moreoverheadlines.xml into a ColdFusion 
structure, and loop over the headlines.
</p>
<a name="xml2dom" />
<h4><a href="<cfoutput>#CGI.Script_Name#</cfoutput>?action=xml2dom">XML2DOM Example</a></h4>
<p>
This is the action I use the most on a daily basis.  XML2DOM loads a XML document from a variable/URL/file into a MSXML DOM object.
In this example I basically replicate the above example (XML2CF) but without using going the extra step of converting it to a native CF data object.
This action is prefered over XML2CF because it does not have to build the CF structure which adds another level of processing.  If your application
is going to be XML intensive, learn the DOM, you won't be disappointed.  On top of that, the DOM object kills the structure created by XML2CF
in terms of speed and flexibility.  By returning the DOM you will have access to all the powers it possesses such as XSLT, Transformations, XML
editing, and creation.<br>
One other note of interest is that we can use the XML2DOM to create a XML document from scratch.  We would do this by calling XML2DOM in this way
&lt;cf_SOXML action="XML2DOM" input="&lt;?XML VERSION=""1.0""&gt;&lt;NEWSFEED&gt;&lt;\NEWSFEED&gt;" output="oNewFeed"&gt;  Then we 
may add additonal elements through methods of the DOM such as createNode().
</p>
<a name="transform" />
<h4><a href="<cfoutput>#CGI.Script_Name#</cfoutput>?action=transform">Transform Example</a></h4>
<p>
New to SOXML 1.5 is the transform action.  By calling SOXML with the action set to "Transform" we may now feed SOXML a XML file/variable and a XSL
file/variable and SOXML will transform the XML into the result created by the XSL.  This can be used to convert XML to a different XML format, HTML,
or any plain text document.  In this example, I transform the news xml into a HTML document using XSL. Check it out!
</p>
<a name="xml2html" />
<h4><a href="<cfoutput>#CGI.Script_Name#</cfoutput>?action=xml2html">XML2HTML Example</a></h4>
<p>
ok, ok. So there is an action that I use more than XML2DOM.  It's XML2HTML.  XML2HTML takes a String/URL/File that represents a XML document
and transforms it into a tree based HMTML representation.  Clicking on nodes with either a "+" or "-" to expand and collapse the branches of the XML
document respectively.  This tag is the most useful when writing your XML applications.  When I run into a problem, I dump the XML that I am working
with to HTML so that I may see what could be going wrong. (Not that I ever run into problems :)
</p>
<a name="references" />
<h3>XML References</h3>
<p>
<a href="http://msdn.microsoft.com/library/default.asp?url=/nhp/Default.asp?contentid=28000438" target="_new">MSDN XML/XSL</a><br>
Documentation on MSXML's interfaces, properties, methods, and examples. 
</p>
<p><a href="http://msdn.microsoft.com/downloads/default.asp?url=/downloads/sample.asp?url=/MSDN-FILES/027/001/772/msdncompositedoc.xml&frame=true" target="_new">MSXML 3.0 SP2</a><br>
Download the latest MSXML object.  
New features include: Server-safe HTTP access, Complete implementation of XSLT/Xpath, Changes to the SAX2 implementation, including new SAX2 helper classes, even higher conformance than the World Wide Web Consortium (W3C) standards.
This is good stuff and definitely a must have.
</p>
<p><a href="http://www.w3.org/XML/" target="_new">W3C XML</a><br>
W3C standards documentation.
</p>
<a name="support" />
<h3>SOXML Support</h3>
<p>
<a href="http://forums.siteobjects.com" target="_new">SiteObjects Forums</a>
</p>

