<!------------------------------------------------------------------
  Project: SOXML Demo
  Template: dsp_demo_soxml_xml2cf.cfm
  Author: Brett Suwyn
  Created: 10/18/2000
  Description: 



------------------------------------------------------------------->

<!--- Gets the Current Directory eg "c:\inetpub\wwwroot\" --->
<cfset sCurrentDirectory = GetDirectoryFromPath(CGI.Path_Translated)>

<!--- This examle Read the XML file on our server's HD into a MSXML DOM object --->
<cf_SOXML 
  action="XML2CF"
  input="#sCurrentDirectory#moreoverheadlines.xml"
  output="stNewsHeadLines"
  type="file">
  
<!--- Now Using the DOM we can do various operations with the XML Document --->
<h3>MoreOver.com Headlines (10/18/2000)</h3>

<!--- Test to see if multiple new items exist --->
<cfif isArray(stNewsHeadlines.MoreOverNews.Article)>
  <!--- Lets loop through the headlines and output the HeadLine, Source, and document URL --->
  <cfloop index="idxArticle" from="1" to="#ArrayLen(stNewsHeadlines.MoreOverNews.Article)#">
  
    <cfscript>
      //Lets grab the nodes of the information we want to display
      sHeadLine = stNewsHeadlines.MoreOverNews.Article[idxArticle].HeadLine_Text.Value;
      sSource =stNewsHeadlines.MoreOverNews.Article[idxArticle].Source.Value;
      sDocumentURL = stNewsHeadlines.MoreOverNews.Article[idxArticle].Document_URL.Value;
    </cfscript>
  
    <table>
      <tr>
        <td><cfoutput><a href="#sDocumentURL#" target="_new">#sHeadLine#</a></cfoutput> <i>source: <cfoutput>#sSource#</cfoutput></i></td>
      </tr>
    </table>
  
  </cfloop>

<cfelse>  <!--- Only one article, no need to loop --->

  <cfscript>
    //Lets grab the nodes of the information we want to display
    sHeadLine = stNewsHeadlines.MoreOverNews.Article.HeadLine_Text.Value;
    sSource =stNewsHeadlines.MoreOverNews.Article.Source.Value;
    sDocumentURL = stNewsHeadlines.MoreOverNews.Article.Document_URL.Value;
  </cfscript>

  <table>
    <tr>
      <td><cfoutput><a href="#sDocumentURL#" target="_new">#sHeadLine#</a></cfoutput> <i>source: <cfoutput>#sSource#</cfoutput></i></td>
    </tr>
  </table>

</cfif>

<!--- Lets output the XML Inline so I can see what I am doing when Im building this --->
<!---   <cf_objectdump object="#stNewsHeadLines#"> --->
